// ==UserScript==
// @name        はてなブックマーク登録数表示
// @description 表示中のWebページがはてなブックマークに登録されている件数をステータスバーに表示するスクリプト
// @namespace   http://www.scriptbrowserk.com/
// @author      Akiyoshi Kozuka
// @include     http://*/*
// @version     0.1
// ==/UserScript==

(function(){

// DebugMode = true

var cstrPanelID = "HtBkNum"
var strCheckedURL

function SetStatusText(strMsg) {
  SrcDocWin.StatusBarText(cstrPanelID) = strMsg
}

function funcError() {
  SetStatusText('Err')
}

function funcOnLoad(res) {
  if (strCheckedURL == SrcDocWin.URL) {
    var strRes = res.responseText
    strRes.match(/<value><int>(\d+)<\/int><\/value>/)
    SetStatusText(RegExp.$1)
  }
}

// メインルーチン
if (StatusBar.PanelExists(cstrPanelID) == false) {
  StatusBar.PanelWidth(cstrPanelID) = 52

  var strFile = SBKScriptItem.Filename

  strFile = strFile.substr(0, strFile.lastIndexOf("\\") + 1) + 'HatenaBkmk.png'
  StatusBar.SetPanelIcon(cstrPanelID, strFile)
}

strCheckedURL = SrcDocWin.URL
var strURL = strCheckedURL

var iPos   = strURL.indexOf("?")
if (iPos >= 0) {
  strURL = strURL.substr(0, iPos)
}
DebugLog("(" + strURL + ")")

SetStatusText('...')

var strPostData = '<?xml version="1.0" encoding="UTF-8"?>' +
                  '<methodCall>' +
                  '<methodName>bookmark.getCount</methodName>' +
                  '<params>' +
                  '<param><value><string>' + strURL + '</string></value></param>' +
                  '</params>' +
                  '</methodCall>';

var strHeaders  = 'Content-Type: text/xml'

var opt = {
    method: 'post',
    url: 'http://b.hatena.ne.jp/xmlrpc',
    data: strPostData,
    header: strHeaders,
    onerror: funcError,
    onload: funcOnLoad
}
GM_xmlhttpRequest(opt)

})();
